/* TimerButton.c generated by valac 0.47.3, the Vala compiler
 * generated from TimerButton.vala, do not modify */

/*
 * Copyright (c) 2011-2018 elementary LLC. (https://github.com/elementary/camera)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Alain M. <alain23@protonmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define CAMERA_WIDGETS_TYPE_TIMER_BUTTON (camera_widgets_timer_button_get_type ())
#define CAMERA_WIDGETS_TIMER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButton))
#define CAMERA_WIDGETS_TIMER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButtonClass))
#define CAMERA_WIDGETS_IS_TIMER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON))
#define CAMERA_WIDGETS_IS_TIMER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_WIDGETS_TYPE_TIMER_BUTTON))
#define CAMERA_WIDGETS_TIMER_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButtonClass))

typedef struct _CameraWidgetsTimerButton CameraWidgetsTimerButton;
typedef struct _CameraWidgetsTimerButtonClass CameraWidgetsTimerButtonClass;
typedef struct _CameraWidgetsTimerButtonPrivate CameraWidgetsTimerButtonPrivate;
typedef enum  {
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED = 0,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC = 3,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC = 5,
	CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC = 10
} CameraWidgetsTimerButtonDelay;

#define CAMERA_WIDGETS_TIMER_BUTTON_TYPE_DELAY (camera_widgets_timer_button_delay_get_type ())
enum  {
	CAMERA_WIDGETS_TIMER_BUTTON_0_PROPERTY,
	CAMERA_WIDGETS_TIMER_BUTTON_NUM_PROPERTIES
};
static GParamSpec* camera_widgets_timer_button_properties[CAMERA_WIDGETS_TIMER_BUTTON_NUM_PROPERTIES];
typedef struct _Block4Data Block4Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _CameraWidgetsTimerButton {
	GtkButton parent_instance;
	CameraWidgetsTimerButtonPrivate * priv;
	CameraWidgetsTimerButtonDelay delay;
};

struct _CameraWidgetsTimerButtonClass {
	GtkButtonClass parent_class;
};

struct _Block4Data {
	int _ref_count_;
	CameraWidgetsTimerButton* self;
	GtkLabel* timer_label;
};

static gpointer camera_widgets_timer_button_parent_class = NULL;
extern GSettings* camera_application_settings;

GType camera_widgets_timer_button_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CameraWidgetsTimerButton, g_object_unref)
GType camera_widgets_timer_button_delay_get_type (void) G_GNUC_CONST;
CameraWidgetsTimerButtonDelay camera_widgets_timer_button_delay_next (CameraWidgetsTimerButtonDelay self);
gchar* camera_widgets_timer_button_delay_to_string (CameraWidgetsTimerButtonDelay self);
CameraWidgetsTimerButton* camera_widgets_timer_button_new (void);
CameraWidgetsTimerButton* camera_widgets_timer_button_construct (GType object_type);
static GObject * camera_widgets_timer_button_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _camera_widgets_timer_button___lambda6_ (Block4Data* _data4_);
static void __camera_widgets_timer_button___lambda6__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static void camera_widgets_timer_button_finalize (GObject * obj);
static GType camera_widgets_timer_button_get_type_once (void);

CameraWidgetsTimerButtonDelay
camera_widgets_timer_button_delay_next (CameraWidgetsTimerButtonDelay self)
{
	CameraWidgetsTimerButtonDelay result = 0;
	switch (self) {
		case CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC:
		{
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC;
			return result;
		}
		case CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC:
		{
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC;
			return result;
		}
		case CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC:
		{
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED;
			return result;
		}
		default:
		{
			result = CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC;
			return result;
		}
	}
}

gchar*
camera_widgets_timer_button_delay_to_string (CameraWidgetsTimerButtonDelay self)
{
	gchar* result = NULL;
	if (self == CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (_ ("Disabled"));
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup_printf (ngettext ("%d Sec", "%d Sec", (gulong) self), (gint) self);
		result = _tmp1_;
		return result;
	}
}

static GType
camera_widgets_timer_button_delay_get_type_once (void)
{
	static const GEnumValue values[] = {{CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_DISABLED", "disabled"}, {CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_3_SEC", "3-sec"}, {CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_5_SEC", "5-sec"}, {CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC, "CAMERA_WIDGETS_TIMER_BUTTON_DELAY_10_SEC", "10-sec"}, {0, NULL, NULL}};
	GType camera_widgets_timer_button_delay_type_id;
	camera_widgets_timer_button_delay_type_id = g_enum_register_static ("CameraWidgetsTimerButtonDelay", values);
	return camera_widgets_timer_button_delay_type_id;
}

GType
camera_widgets_timer_button_delay_get_type (void)
{
	static volatile gsize camera_widgets_timer_button_delay_type_id__volatile = 0;
	if (g_once_init_enter (&camera_widgets_timer_button_delay_type_id__volatile)) {
		GType camera_widgets_timer_button_delay_type_id;
		camera_widgets_timer_button_delay_type_id = camera_widgets_timer_button_delay_get_type_once ();
		g_once_init_leave (&camera_widgets_timer_button_delay_type_id__volatile, camera_widgets_timer_button_delay_type_id);
	}
	return camera_widgets_timer_button_delay_type_id__volatile;
}

CameraWidgetsTimerButton*
camera_widgets_timer_button_construct (GType object_type)
{
	CameraWidgetsTimerButton * self = NULL;
	self = (CameraWidgetsTimerButton*) g_object_new (object_type, NULL);
	return self;
}

CameraWidgetsTimerButton*
camera_widgets_timer_button_new (void)
{
	return camera_widgets_timer_button_construct (CAMERA_WIDGETS_TYPE_TIMER_BUTTON);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		CameraWidgetsTimerButton* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->timer_label);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
_camera_widgets_timer_button___lambda6_ (Block4Data* _data4_)
{
	CameraWidgetsTimerButton* self;
	CameraWidgetsTimerButtonDelay _tmp0_;
	GSettings* _tmp1_;
	CameraWidgetsTimerButtonDelay _tmp2_;
	GtkLabel* _tmp3_;
	CameraWidgetsTimerButtonDelay _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	self = _data4_->self;
	_tmp0_ = self->delay;
	self->delay = camera_widgets_timer_button_delay_next (_tmp0_);
	_tmp1_ = camera_application_settings;
	_tmp2_ = self->delay;
	g_settings_set_enum (_tmp1_, "delay", (gint) _tmp2_);
	_tmp3_ = _data4_->timer_label;
	_tmp4_ = self->delay;
	_tmp5_ = camera_widgets_timer_button_delay_to_string (_tmp4_);
	_tmp6_ = _tmp5_;
	gtk_label_set_label (_tmp3_, _tmp6_);
	_g_free0 (_tmp6_);
}

static void
__camera_widgets_timer_button___lambda6__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
	_camera_widgets_timer_button___lambda6_ (self);
}

static GObject *
camera_widgets_timer_button_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CameraWidgetsTimerButton * self;
	Block4Data* _data4_;
	GSettings* _tmp0_;
	GtkImage* timer_image = NULL;
	GtkImage* _tmp1_;
	CameraWidgetsTimerButtonDelay _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp7_;
	GtkGrid* _tmp8_;
	GtkImage* _tmp9_;
	GtkGrid* _tmp10_;
	GtkLabel* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkGrid* _tmp13_;
	parent_class = G_OBJECT_CLASS (camera_widgets_timer_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButton);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = camera_application_settings;
	self->delay = (CameraWidgetsTimerButtonDelay) g_settings_get_enum (_tmp0_, "delay");
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("timer-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
	g_object_ref_sink (_tmp1_);
	timer_image = _tmp1_;
	_tmp2_ = self->delay;
	_tmp3_ = camera_widgets_timer_button_delay_to_string (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
	g_object_ref_sink (_tmp5_);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_data4_->timer_label = _tmp6_;
	g_signal_connect_data ((GtkButton*) self, "clicked", (GCallback) __camera_widgets_timer_button___lambda6__gtk_button_clicked, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp7_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp7_);
	main_grid = _tmp7_;
	_tmp8_ = main_grid;
	_tmp9_ = timer_image;
	gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
	_tmp10_ = main_grid;
	_tmp11_ = _data4_->timer_label;
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Delay before photo is taken"));
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp12_, GTK_STYLE_CLASS_FLAT);
	_tmp13_ = main_grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
	_g_object_unref0 (main_grid);
	_g_object_unref0 (timer_image);
	return obj;
}

static void
camera_widgets_timer_button_class_init (CameraWidgetsTimerButtonClass * klass,
                                        gpointer klass_data)
{
	camera_widgets_timer_button_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = camera_widgets_timer_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = camera_widgets_timer_button_finalize;
}

static void
camera_widgets_timer_button_instance_init (CameraWidgetsTimerButton * self,
                                           gpointer klass)
{
}

static void
camera_widgets_timer_button_finalize (GObject * obj)
{
	CameraWidgetsTimerButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_TIMER_BUTTON, CameraWidgetsTimerButton);
	G_OBJECT_CLASS (camera_widgets_timer_button_parent_class)->finalize (obj);
}

static GType
camera_widgets_timer_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CameraWidgetsTimerButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_widgets_timer_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraWidgetsTimerButton), 0, (GInstanceInitFunc) camera_widgets_timer_button_instance_init, NULL };
	GType camera_widgets_timer_button_type_id;
	camera_widgets_timer_button_type_id = g_type_register_static (gtk_button_get_type (), "CameraWidgetsTimerButton", &g_define_type_info, 0);
	return camera_widgets_timer_button_type_id;
}

GType
camera_widgets_timer_button_get_type (void)
{
	static volatile gsize camera_widgets_timer_button_type_id__volatile = 0;
	if (g_once_init_enter (&camera_widgets_timer_button_type_id__volatile)) {
		GType camera_widgets_timer_button_type_id;
		camera_widgets_timer_button_type_id = camera_widgets_timer_button_get_type_once ();
		g_once_init_leave (&camera_widgets_timer_button_type_id__volatile, camera_widgets_timer_button_type_id);
	}
	return camera_widgets_timer_button_type_id__volatile;
}

